VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CRMConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"ConnectionParams"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit
Option Base 0

' CRMConnection class
'
' Represents server data exchange using Concourse Suite XML API
'

' Concourse Suite XML data exchange processing page name.
Const PAGE_PACKET_PROCESSING = "ProcessPacket.do"

Private m_params As New ConnectionParams

' Connection parameters collection
' Could be either set up mannually or created using helper methods like this
'
' set connection.ConnectionParams = CreateConnectionParamsWithBasicAuthentication(url, userName, password)
'
Public Property Get ConnectionParams() As ConnectionParams
    Set ConnectionParams = m_params
End Property

Public Property Set ConnectionParams(ByVal value As ConnectionParams)
    Set m_params = value
End Property

' Sends request XML to server with given timeout and returns server response XML text.
'
Public Function Send(ByVal requestXML As String, ByVal timeout As Integer) As String
    Dim XML As String
    
    XML = GetCompleteRequestXml(requestXML)
    CentricApp.Logger.Debugging "Sending server request: " & requestXML
    
    Dim request As New MSXML.XMLHTTPRequest
    If request Is Nothing Then
        CentricApp.Logger.Debugging "Couldn't create object: MSXML.XMLHTTPRequest."
        Err.Raise ERR_UNEXPECTED, Description:=MSG_ERR_UNEXPECTED & vbCrLf & _
        "Couldn't create object: MSXML.XMLHTTPRequest."
    End If
    Dim Url As String
    Url = UrlUtils.GetNormalizedUrl(ConnectionParams.Item(CONNECTION_PARAM_URL)) & PAGE_PACKET_PROCESSING
    CentricApp.Logger.Debugging "Sending request to server (" & Url & ")."
    request.Open "post", Url, False
    
    request.setRequestHeader "Content-Type", "text/xml"
    request.setRequestHeader "Content-Length", Len(XML)
    XML = vbCrLf & vbCrLf & XML
    
    request.Send XML
    
    Dim currentDate As Date
    currentDate = Now
    Do While (Abs(DateDiff("s", currentDate, Now)) < timeout)
        If request.readyState = 4 Then
            XML = request.responseText
            Exit Do
        End If
    Loop
    
    Send = XML
    CentricApp.Logger.Debugging "Server response: " & XML
End Function

Private Function GetCompleteRequestXml(requestXML As String) As String
    GetCompleteRequestXml = "<app>" & vbCrLf & _
    GetAuthentificationXml & vbCrLf & _
    requestXML & vbCrLf & _
    "</app>"
End Function

Private Function GetAuthentificationXml() As String
    Dim result As String
    
    result = "<authentication>" & vbCrLf & _
    "<id>" & UrlUtils.GetHost(ConnectionParams.Item(CONNECTION_PARAM_URL)) & "</id>" & vbCrLf & _
    "<systemId>4</systemId>" & vbCrLf & _
    "<username>" & ConnectionParams.Item(CONNECTION_PARAM_USER_NAME) & "</username>" & vbCrLf & _
    "<code>" & ConnectionParams.Item(CONNECTION_PARAM_PASSWORD) & "</code>" & vbCrLf & _
    "</authentication>"

    
    GetAuthentificationXml = result
End Function
