VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CRMOperation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit
Option Base 0

' CRMOperation class
'
' Represents single operation in Concourse Suite XML API
'
Private m_action As RequestedOperation
Private m_target As String
Private m_conditions As New dictionary
Private m_shareKey As Boolean

' Operation action
' One of RequestedOperation constants
'
Public Property Get Action() As Integer
    Action = m_action
End Property

Public Property Let Action(value As Integer)
    m_action = value
End Property

' Target object/table name
'
Public Property Get Target() As String
    Target = m_target
End Property

Public Property Let Target(value As String)
    m_target = value
End Property

' Collection of conditions, a list of fields with values
' to find specific object(s)
'
Public Property Get Conditions() As dictionary
    Set Conditions = m_conditions
End Property

Public Property Get ShareKey() As Boolean
    ShareKey = m_shareKey
End Property

Public Property Let ShareKey(value As Boolean)
    m_shareKey = value
End Property

Public Function XML() As String
Attribute XML.VB_UserMemId = 0
    Dim result As String
    
    result = "<" & Target & " action="""
    
    Select Case Action
        Case Is = opSelect
            result = result & "select"
        Case Is = opInsert
            result = result & "insert"
        Case Is = opUpdate
            result = result & "update"
        Case Is = opDelete
            result = result & "delete"
    End Select
    
    result = result & """"
    If ShareKey Then
        result = result & " shareKey=""true"""
    End If
    result = result & "> " & vbCrLf
    
    Dim key As Variant
    For Each key In Conditions.Keys
        result = result & "<" & key & ">" & _
        Conditions(key) & _
        "</" & key & ">" & vbCrLf
    Next key
    
    result = result & "</" & Target & ">"
    XML = result
End Function


