VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CRMRequest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit
Option Base 0

' CRMRequest class
'
' Represents Concourse Suite XML API batch request.
'

Private m_transactions As New Collection

' Adds a transaction into the request's batch
'
Public Sub Add(Item As CRMTransaction)
    m_transactions.Add Item
End Sub

' Gets the request XML text.
' As long as the property made default, the next two code fragments are equivalent:
'
' 1.
' textXML = connection.Send(request.XML, timeout)
'
' 2.
' textXML = connection.Send(request, timeout)
'
Public Property Get XML() As String
Attribute XML.VB_UserMemId = 0
    XML = GetXML
    Exit Function
    
    Dim result As String
    
    Dim i As Integer
    Dim t As CRMTransaction
    
    i = 0
    For Each t In m_transactions
        i = i + 1
        result = result & t
        If i = m_transactions.Count Then
            result = result & vbCrLf
        End If
    Next t
    
    XML = result
End Property

Private Function GetXML() As String
    Dim result As String
    
    Dim i As Integer
    Dim t As CRMTransaction
    
    i = 0
    For Each t In m_transactions
        i = i + 1
        result = result & GetTransactionXML(t)
        If i = m_transactions.Count Then
            result = result & vbCrLf
        End If
    Next t
    
    GetXML = result
End Function

Private Function GetTransactionXML(ByVal t As CRMTransaction) As String
    Dim doc As New MSXML.DOMDocument
    If doc Is Nothing Then
        CentricApp.Logger.Debugging "Couldn't create object: MSXML.DOMDocument."
        Err.Raise ERR_UNEXPECTED, Description:=MSG_ERR_UNEXPECTED & vbCrLf & _
        "Couldn't create object: MSXML.DOMDocument."
    End If
    Dim root As IXMLDOMElement
    Set root = doc.createElement("transaction")
    doc.appendChild root
    root.setAttribute "id", t.ID
    
    If t.Properties.Count > 0 Then
        Dim meta As IXMLDOMElement
        Set meta = doc.createElement("meta")
        root.appendChild meta
        
        Dim prop As Variant
        For Each prop In t.Properties
            Dim element As IXMLDOMElement
            Set element = doc.createElement("property")
            meta.appendChild element
            element.text = prop
        Next prop
    End If
    
    Dim op As CRMOperation
    For Each op In t.Operations
        AddOperation root, op
    Next op
    doc.preserveWhiteSpace = True
    GetTransactionXML = doc.XML
End Function

Private Sub AddOperation(ByVal parent As IXMLDOMElement, ByVal op As CRMOperation)
    Dim doc As DOMDocument
    Set doc = parent.OwnerDocument
    
    Dim opElement As IXMLDOMElement
    Set opElement = doc.createElement(op.Target)
    parent.appendChild opElement
    
    Dim Action As String
    
    Select Case op.Action
        Case Is = opSelect
            Action = "select"
        Case Is = opInsert
            Action = "insert"
        Case Is = opUpdate
            Action = "update"
        Case Is = opDelete
            Action = "delete"
    End Select
    opElement.setAttribute "action", Action
    
    If op.ShareKey Then
        opElement.setAttribute "shareKey", "true"
    End If
    
    Dim key As Variant
    Dim element As IXMLDOMElement
    For Each key In op.Conditions.Keys
        Set element = doc.createElement(key)
        opElement.appendChild element
        element.text = op.Conditions(key)
    Next key
    
End Sub
