VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CRMTransaction"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit
Option Base 0

' CRMTransaction class.
'
' Represents transactional request in Concourse Suite XML API
'

Private m_ID As Integer
Private m_properties As New Collection
Private m_operations As New Collection

' Autogenerated unique transaction ID
Property Get ID() As Integer
    ID = m_ID
End Property

' Collection of requested properties of object/table
' (transaction META section)
'
Public Property Get Properties() As Collection
    Set Properties = m_properties
End Property

Public Sub Add(op As CRMOperation)
    m_operations.Add op
End Sub

Public Property Get Operations() As Collection
    Set Operations = m_operations
End Property

' Transaction XML text
'
Public Property Get XML() As String
Attribute XML.VB_UserMemId = 0
    Dim result As String
    
    result = "<transaction id=""" & ID & """>" & vbCrLf & GetMetaSection
    
    Dim op As CRMOperation
    For Each op In m_operations
        result = result & op & vbCrLf
    Next op

    result = result & "</transaction>"

    XML = result
End Property

Private Function GetMetaSection() As String
    If Properties.Count = 0 Then
        GetMetaSection = ""
    Else
        Dim result As String
        result = "<meta>" & vbCrLf
        
        Dim prop As Variant
        For Each prop In Properties
            result = result & "<property>" & prop & "</property>" & vbCrLf
        Next prop
        
        result = result & "</meta>" & vbCrLf
        GetMetaSection = result
    End If
End Function

Private Sub Class_Initialize()
    m_ID = NextTransactionID
End Sub
