VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CentricApp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Logger"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member1" ,"Preferences"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit
Option Base 0

Private Const FOLDER_IMPORTED_ITEMS = "history"
Private Const FILE_IMPORTED_CONTACTS = "contacts.dat"
Private Const FILE_IMPORTED_TASKS = "tasks.dat"
Private Const FILE_IMPORTED_MAIL = "mail.dat"



Public EnableBar As Boolean
Private UserIDAvailable As Boolean
Private m_userID As Integer
Private m_contactID As Integer
Private m_logger As Logger
Private m_importedContacts As PersistentList
Private m_importedMail As PersistentList
Private m_importedTasks As PersistentList
Private m_outlook As Outlook.Application
Private m_userTimezone As String

Private WithEvents m_Preferences As Preferences
Attribute m_Preferences.VB_VarHelpID = -1

Private Sub Class_Initialize()
    Set m_Preferences = New Preferences
    m_Preferences.Load
    
    Set m_logger = New Logger
    m_logger.Level = Preferences.LogLevel
    
    Dim path As String
    path = ShellUtils.GetPluginDataFolder & "\" & FOLDER_IMPORTED_ITEMS & "\"
    
    Set m_importedContacts = New PersistentList
    m_importedContacts.Init path + FILE_IMPORTED_CONTACTS
    
    Set m_importedMail = New PersistentList
    m_importedMail.Init path + FILE_IMPORTED_MAIL
    
    Set m_importedTasks = New PersistentList
    m_importedTasks.Init path + FILE_IMPORTED_TASKS
    
    'RetrieveUserTimezone
    
    EnableBar = True
    UserIDAvailable = False
End Sub

Public Property Get Preferences() As Preferences
    Set Preferences = m_Preferences
End Property

Public Property Get UserID() As Integer
    If Not UserIDAvailable Then
        Dim params As ConnectionParams
        Set params = CreateConnectionParamsWithBasicAuthentication( _
            Preferences.Url, _
            Preferences.UserName, _
            Preferences.Password _
        )
        m_userID = GetUserId(params, Preferences.UserName)
        m_contactID = GetContactIDByUserID(m_userID)
        
        RetrieveUserTimezone
        
        UserIDAvailable = True
    End If
    UserID = m_userID
End Property

Public Property Get ContactID() As Integer
    ContactID = m_contactID
End Property

Private Sub m_Preferences_PasswordChanged(oldValue As String, NewValue As String)
    UserIDAvailable = False
End Sub

Private Sub m_Preferences_UrlChanged(oldValue As String, NewValue As String)
    UserIDAvailable = False
End Sub

Private Sub m_Preferences_UserNameChanged(oldValue As String, NewValue As String)
    UserIDAvailable = False
End Sub

Public Property Get Logger() As Logger
    Set Logger = m_logger
End Property

Public Property Get ImportedContacts() As PersistentList
    Set ImportedContacts = m_importedContacts
End Property

Public Property Get ImportedTasks() As PersistentList
    Set ImportedTasks = m_importedTasks
End Property

Public Property Get ImportedMail() As PersistentList
    Set ImportedMail = m_importedMail
End Property

Public Property Get Outlook() As Outlook.Application
    Set Outlook = m_outlook
End Property

Public Property Set Outlook(value As Outlook.Application)
    Set m_outlook = value
End Property

Public Property Get UserTimezone() As String
    If m_userTimezone = "" Then RetrieveUserTimezone
    UserTimezone = m_userTimezone
End Property

Private Sub RetrieveUserTimezone()
    CentricApp.Logger.Debugging "Retrieving user time zone..."
    On Error GoTo handleError
    
    m_userTimezone = ""
    
    Dim transaction As New CRMTransaction
    With transaction.Properties
        .Add "timeZone"
    End With
    
    Dim op As New CRMOperation
    op.Action = opSelect
    op.Target = "userList"
    op.Conditions.Add "id", m_userID

    transaction.Add op
    
    Dim request As New CRMRequest
    request.Add transaction

    Dim conn As New CRMConnection
    Set conn.ConnectionParams = CreateConnectionParamsWithBasicAuthentication( _
        Preferences.Url, _
        Preferences.UserName, _
        Preferences.Password _
    )
    
    Dim response As New CRMResponse
    response = conn.Send(request, 60)

    Dim rs As CRMResultSet
    Set rs = response.ResultSetByID(transaction.ID)
    If (rs Is Nothing) Or rs.IsError Then
        Err.Raise rs.ErrorCode, Description:=rs.ErrorText
    End If

    If (rs.Items.Count <= 0) Then
        CentricApp.Logger.Debugging "User time zone not found."
    Else
        m_userTimezone = rs.Items(1)("timeZone")
        CentricApp.Logger.Debugging "User timezone retrieved: " & m_userTimezone
    End If
    Exit Sub
    
handleError:
    CentricApp.Logger.Debugging "Error retrieving user time zone: " & Err.Number & ", " & Err.Description
    
End Sub



