VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ContactManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit

Private m_cache As New dictionary

Public Function IsContactExists(ByVal EmailAddress As String) As Boolean
    If m_cache.Exists(EmailAddress) Then
        IsContactExists = True
        Exit Function
    End If
    
    On Error GoTo handleError

    Dim ID As String
    ID = FindContactIDFromEmail(EmailAddress)
    IsContactExists = True
    m_cache.Add EmailAddress, ID
    Exit Function
    
handleError:
    IsContactExists = False
End Function

Public Function AddContact(ByVal Email As String, Optional FirstName As Variant, Optional MiddleName As Variant, _
    Optional LastName As Variant, Optional Company As Variant, Optional Title As Variant, _
    Optional Role As Variant) As String
    
    CentricApp.Logger.Debugging "Creating new CRM contact (first name:" & CStr(FirstName) & _
    ", middlename: " & CStr(MiddleName) & ", last name: " & CStr(LastName) & ", company: " & CStr(Company) & _
    ", title: " & CStr(Title) & ", role: " & CStr(Role) & ", email: " & Email & ")"
    
    Dim ID As Integer
    ID = CentricApp.UserID
    
    Dim transaction As New CRMTransaction
    transaction.Properties.Add "id"
    
    Dim op As New CRMOperation
    op.Action = opInsert
    op.Target = "contact"
    op.ShareKey = True
    With op.Conditions
        If Not IsMissing(Company) Then .Add "company", Company
        If Not IsMissing(Company) Then .Add "orgName", Company
        If Not IsMissing(Title) Then .Add "title", Title
        If Not IsMissing(FirstName) Then .Add "nameFirst", FirstName
        If Not IsMissing(MiddleName) Then .Add "nameMiddle", MiddleName
        If Not IsMissing(LastName) Then .Add "nameLast", LastName
        If Not IsMissing(Role) Then .Add "role", Role
        .Add "disableNameValidation", True
        .Add "accessType", 2
        .Add "enteredBy", ID
        .Add "modifiedBy", ID
        .Add "owner", ID
        If CentricApp.Preferences.ImportContactAsLead Then
            .Add "isLead", "true"
            .Add "leadStatus", 2
        End If
    End With
    transaction.Add op
    
    Set op = GetContactEmailOperation(Email)
    transaction.Add op
    
    Dim request As New CRMRequest
    request.Add transaction
    
    Dim conn As New CRMConnection
    Set conn.ConnectionParams = CreateConnectionParamsWithBasicAuthentication( _
        CentricApp.Preferences.Url, _
        CentricApp.Preferences.UserName, _
        CentricApp.Preferences.Password _
    )
    
    Dim response As New CRMResponse
    response = conn.Send(request, 60)
    
    Dim rs As CRMResultSet
    Set rs = response.ResultSetByID(transaction.ID)
    
    If rs.IsError Then
        Err.Raise rs.ErrorCode, Description:=rs.ErrorText
    End If
    
    AddContact = Val(rs(1)("id"))
    
    m_cache.Add Email, AddContact
    
    CentricApp.Logger.Debugging "CRM contact created with ID=" & AddContact
    
End Function

Public Function GetContactID(ByVal Email As String) As String
    If m_cache.Exists(Email) Then
        GetContactID = m_cache.Item(Email)
        Exit Function
    End If
    
    Dim ID As String
    ID = FindContactIDFromEmail(Email)
    m_cache.Add Email, ID
    GetContactID = ID
End Function

Public Sub CacheEmail(ByVal Email As String, ByVal ID As String)
    m_cache.Add Email, ID
End Sub

Public Sub ClearCache()
    m_cache.RemoveAll
End Sub
