VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FolderList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.


Option Explicit
Option Base 0

Private m_Folders As dictionary

Public Property Get Count() As Integer
    Count = m_Folders.Count
End Property

Public Property Get Item(ByVal Index As Variant) As String
Attribute Item.VB_UserMemId = 0
    If IsNumeric(Index) Then
        Item = m_Folders.Item(m_Folders.Keys(CInt(Index)))
    ElseIf Contains(Index) Then
        Item = m_Folders.Item(Index)
    End If
End Property

Public Property Get Contains(ByVal Folder As String) As Boolean
    Contains = m_Folders.Exists(Folder)
End Property

Public Sub Add(ByVal Folder As String)
    If (Contains(Folder)) Then Exit Sub
    m_Folders.Add Folder, Folder
End Sub

Public Sub Remove(ByVal Index As Variant)
    m_Folders.Remove (Index)
End Sub

Public Sub Clear()
    m_Folders.RemoveAll
End Sub

Public Property Get AsString() As String
    If (Count = 0) Then
        AsString = ""
        Exit Function
    End If
    Dim result As String
    result = Item(0)
    Dim i As Integer
    i = 1
    Do While (i < Count)
        result = result & FOLDER_LIST_SEPARATOR & Item(i)
        i = i + 1
    Loop
    AsString = result
End Property

Public Property Let AsString(ByVal text As String)
    Dim splitted() As String
    splitted = Split(text, FOLDER_LIST_SEPARATOR, Compare:=vbTextCompare)
    Clear
    Dim i As Integer
    For i = LBound(splitted) To UBound(splitted)
        If Not IsNull(splitted(i)) Then
            Add splitted(i)
        End If
    Next i
End Property

Private Sub Class_Initialize()
    Set m_Folders = New dictionary
    m_Folders.CompareMode = TextCompare
End Sub


Private Sub Class_Terminate()
    Set m_Folders = Nothing
End Sub
