VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Logger"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"Class1"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit

Private Const FILE_NAME = "ConcourseSuite.log"

Private m_level As Integer
Private m_stream As TextStream


Public Property Get Level() As Integer
    Level = m_level
End Property

Public Property Let Level(newLevel As Integer)
    m_level = newLevel
End Property

Public Sub Log(Message As String, severity As Integer)
    If Level >= severity Then
        DoLog Message, severity
    End If
End Sub

Private Sub DoLog(Message As String, severity As Integer)
    m_stream.WriteLine FormatDateTime(Now, vbLongDate) & _
    " [" & GetSeverityText(severity) & "] " & _
    Message
End Sub

Private Function GetSeverityText(severity As Integer) As String
    Select Case severity
        Case logNoLogging
            GetSeverityText = ""
        Case logErrors
            GetSeverityText = "ERROR"
        Case logWarnings
            GetSeverityText = "WARNING"
        Case logInfo
            GetSeverityText = "INFO"
        Case logDebug
            GetSeverityText = "DEBUG"
    End Select
End Function

Public Sub Error(Message As String)
    Log Message, logErrors
End Sub

Public Sub Warning(Message As String)
    Log Message, logWarnings
End Sub

Public Sub Info(Message As String)
    Log Message, logInfo
End Sub

Public Sub Debugging(Message As String)
    Log Message, logDebug
End Sub

Private Sub Class_Initialize()
    Dim path As String
    path = ShellUtils.GetPluginDataFolder & "\" & FILE_NAME
    Set m_stream = ShellUtils.OpenTextFile(path, ForWriting)
End Sub

Private Sub Class_Terminate()
    If Not (m_stream Is Nothing) Then
        m_stream.Close
        Set m_stream = Nothing
    End If
End Sub
