VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PersistentList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit

' PersistentList class
'
' Maintains a list of previousely imported object IDs between sessions.
' Allows to check if an object has been already imported and avoid duplicates.

Private m_folderPath As String
Private m_fileName As String
Private m_dictionary As dictionary
Private m_loaded As Boolean

Public Sub Init(fileName As String)
    m_fileName = fileName
End Sub

Public Function Contains(ID As String) As Boolean
    If Not m_loaded Then
        Load
    End If
    
    Contains = m_dictionary.Exists(ID)
End Function

Public Sub Add(ID As String)
    On Error GoTo handleError
    
    If Contains(ID) Then
        Exit Sub
    Else
        m_dictionary.Add ID, ID
    End If
    
    Dim stream As TextStream
    Set stream = ShellUtils.OpenTextFile(m_fileName, ForAppending)
    stream.WriteLine ID
    
    ' Note that next code block should be executed anyway, was there an error or not
    ' (like for Java finally block)
handleError:
    If Not stream Is Nothing Then
        stream.Close
    End If
    
End Sub

Private Sub Class_Initialize()
    m_loaded = False
    Set m_dictionary = New dictionary
End Sub

Private Sub Load()
    On Error GoTo handleError
    
    Dim stream As TextStream
    Set stream = ShellUtils.OpenTextFile(m_fileName, ForReading)
    
    Dim ID As String
    Do While Not stream.AtEndOfStream
        ID = stream.ReadLine
        m_dictionary.Add ID, ID
    Loop
    
    ' Note that next code block should be executed anyway, was there an error or not
    ' (like for Java finally block)
handleError:
    m_loaded = True
    If Not stream Is Nothing Then
        stream.Close
    End If
    
End Sub
