VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Preferences"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit
Option Base 0

' Registry location constants for preferences storing
Private Const REG_APP_NAME = "Concourse Suite Outlook Add-In"

Private Const REG_SECTION_LOGIN = "LoginDetails"
Private Const REG_SECTION_CONFIG = "Config"
Private Const REG_SECTION_CONTACTS = "Contacts"
Private Const REG_SECTION_SYNC = "Sync"

Private Const REG_KEY_USER_NAME = "UserName"
Private Const REG_KEY_PASSWORD = "Password"
Private Const REG_KEY_URL = "Url"
Private Const REG_KEY_LOGGING = "Logging"
Private Const REG_KEY_IMPORT_CONTACT_AS_LEAD = "ImportAsLead"
Private Const REG_KEY_SYNC_CONTACTS = "Contacts"
Private Const REG_KEY_SYNC_TASKS = "Tasks"
Private Const REG_KEY_SYNC_EMAIL = "Email"
Private Const REG_KEY_SYNC_APPOINTMENTS = "Appointments"
Private Const REG_KEY_SYNC_INTERVAL = "Interval"
Private Const REG_KEY_SYNC_SEARCH_IN_FOLDERS = "SearchInFolders"
Private Const REG_KEY_SYNC_IGNORE_FOLDERS = "IgnoreFolders"
Private Const REG_KEY_SYNC_LAST_SYNC = "LastSync"

Private Const DATE_FORMAT = "D\.MM\.yyyy\ hh:mm:ss"

' Preferences values
Private m_UserName As String
Private m_Url As String
Private m_Password As String
Private m_LogLevel As Integer
Private m_ImportContactAsLead As Boolean
Private m_SyncContacts As Boolean
Private m_SyncTasks As Boolean
Private m_SyncEmail As Boolean
Private m_SyncAppointments As Boolean
Private m_SyncInterval As Integer
Private m_SyncSearchInFolders As String
Private m_SyncIgnoreFolders As String
Private m_LastSync As Date

' Dirty flag
Private m_Saved As Boolean

' Events
Public Event UserNameChanged(oldValue As String, NewValue As String)
Public Event PasswordChanged(oldValue As String, NewValue As String)
Public Event UrlChanged(oldValue As String, NewValue As String)
Public Event Changed()
Public Event Loaded()


' Loads preferences from registry
Public Sub Load()
    m_UserName = GetSetting(REG_APP_NAME, REG_SECTION_LOGIN, REG_KEY_USER_NAME, "")
    m_Password = GetSetting(REG_APP_NAME, REG_SECTION_LOGIN, REG_KEY_PASSWORD, "")
    m_Url = GetSetting(REG_APP_NAME, REG_SECTION_LOGIN, REG_KEY_URL, "")
    
    m_ImportContactAsLead = GetSetting(REG_APP_NAME, REG_SECTION_CONTACTS, REG_KEY_IMPORT_CONTACT_AS_LEAD, False)
    
    m_SyncContacts = GetSetting(REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_CONTACTS, False)
    m_SyncTasks = GetSetting(REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_TASKS, False)
    m_SyncEmail = GetSetting(REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_EMAIL, False)
    m_SyncAppointments = GetSetting(REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_APPOINTMENTS, False)
    m_SyncInterval = GetSetting(REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_INTERVAL, 0)
    m_SyncSearchInFolders = GetSetting(REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_SEARCH_IN_FOLDERS, FOLDER_LIST_DEFAULT)
    m_SyncIgnoreFolders = GetSetting(REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_IGNORE_FOLDERS, FOLDER_LIST_DEFAULT)
    
    Dim str_lastSync As String
    str_lastSync = GetSetting(REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_LAST_SYNC, FormatDate(Now))
    m_LastSync = ParseDate(str_lastSync)
    
    
    Dim str_loglevel As String
    str_loglevel = GetSetting(REG_APP_NAME, REG_SECTION_CONFIG, REG_KEY_LOGGING, "0")
    m_LogLevel = logNoLogging
    On Error Resume Next
    m_LogLevel = Val(str_loglevel)
    
    m_Saved = True
    RaiseEvent Loaded
End Sub

' Saves preferences to registry
Public Sub Save()
    SaveSetting REG_APP_NAME, REG_SECTION_LOGIN, REG_KEY_USER_NAME, m_UserName
    SaveSetting REG_APP_NAME, REG_SECTION_LOGIN, REG_KEY_PASSWORD, m_Password
    SaveSetting REG_APP_NAME, REG_SECTION_LOGIN, REG_KEY_URL, m_Url
    SaveSetting REG_APP_NAME, REG_SECTION_CONTACTS, REG_KEY_IMPORT_CONTACT_AS_LEAD, m_ImportContactAsLead
    SaveSetting REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_CONTACTS, m_SyncContacts
    SaveSetting REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_TASKS, m_SyncTasks
    SaveSetting REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_EMAIL, m_SyncEmail
    SaveSetting REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_APPOINTMENTS, m_SyncAppointments
    SaveSetting REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_INTERVAL, m_SyncInterval
    SaveSetting REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_SEARCH_IN_FOLDERS, m_SyncSearchInFolders
    SaveSetting REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_IGNORE_FOLDERS, m_SyncIgnoreFolders
    SaveSetting REG_APP_NAME, REG_SECTION_SYNC, REG_KEY_SYNC_LAST_SYNC, FormatDate(m_LastSync)
    SaveSetting REG_APP_NAME, REG_SECTION_CONFIG, REG_KEY_LOGGING, m_LogLevel
    m_Saved = True
End Sub

' Properties
Public Property Get UserName() As String
    UserName = m_UserName
End Property

Public Property Let UserName(value As String)
    Dim oldValue As String
    oldValue = m_UserName
    m_UserName = value
    SetChanged
    RaiseEvent UserNameChanged(oldValue, value)
End Property

Public Property Get Password() As String
    Password = m_Password
End Property

Public Property Let Password(value As String)
    Dim oldValue As String
    oldValue = m_Password
    m_Password = value
    SetChanged
    RaiseEvent PasswordChanged(oldValue, value)
End Property

Public Property Get Url() As String
    Url = m_Url
End Property

Public Property Let Url(value As String)
    Dim oldValue As String
    oldValue = m_Url
    m_Url = value
    SetChanged
    RaiseEvent UrlChanged(oldValue, value)
End Property

Public Property Get LogLevel() As Integer
    LogLevel = m_LogLevel
End Property

Public Property Get ImportContactAsLead() As Boolean
    ImportContactAsLead = m_ImportContactAsLead
End Property

Public Property Let ImportContactAsLead(value As Boolean)
    m_ImportContactAsLead = value
    SetChanged
End Property

Public Property Get SyncContacts() As Boolean
    SyncContacts = m_SyncContacts
End Property

Public Property Let SyncContacts(value As Boolean)
    m_SyncContacts = value
    SetChanged
End Property

Public Property Get SyncTasks() As Boolean
    SyncTasks = m_SyncTasks
End Property

Public Property Let SyncTasks(value As Boolean)
    m_SyncTasks = value
    SetChanged
End Property

Public Property Get SyncEmail() As Boolean
    SyncEmail = m_SyncEmail
End Property

Public Property Let SyncEmail(value As Boolean)
    m_SyncEmail = value
    SetChanged
End Property

Public Property Get SyncAppointments() As Boolean
    SyncAppointments = m_SyncAppointments
End Property

Public Property Let SyncAppointments(value As Boolean)
    m_SyncAppointments = value
    SetChanged
End Property

Public Property Get SyncInterval() As Integer
    SyncInterval = m_SyncInterval
End Property

Public Property Let SyncInterval(value As Integer)
    m_SyncInterval = value
    SetChanged
End Property

Public Property Get SyncSearchInFolders() As String
    If (CentricApp.Outlook Is Nothing) Then
        SyncSearchInFolders = FOLDER_LIST_DEFAULT
        Exit Property
    End If
    If (m_SyncSearchInFolders = FOLDER_LIST_DEFAULT) Then m_SyncSearchInFolders = GetDefaultSyncFolders()
    SyncSearchInFolders = m_SyncSearchInFolders
End Property

Public Property Let SyncSearchInFolders(ByVal value As String)
    m_SyncSearchInFolders = value
    SetChanged
End Property

Public Property Get SyncIgnoreFolders() As String
    If (CentricApp.Outlook Is Nothing) Then
        SyncSearchInFolders = FOLDER_LIST_DEFAULT
        Exit Property
    End If
    If (m_SyncIgnoreFolders = FOLDER_LIST_DEFAULT) Then m_SyncIgnoreFolders = GetDefaultIgnoreFolders()
    SyncIgnoreFolders = m_SyncIgnoreFolders
End Property

Public Property Let SyncIgnoreFolders(ByVal value As String)
    m_SyncIgnoreFolders = value
    SetChanged
End Property

Public Property Get LastSync() As Date
    LastSync = m_LastSync
End Property

Public Property Let LastSync(ByVal newDate As Date)
    m_LastSync = newDate
End Property


Private Sub SetChanged()
    If Not m_Saved Then Exit Sub
    m_Saved = False
    RaiseEvent Changed
End Sub

Private Function FormatDate(ByVal aDate As Date) As String
    FormatDate = Format$(Year(aDate), "0000") & _
    Format$(Month(aDate), "00") & _
    Format$(Day(aDate), "00") & _
    Format$(Hour(aDate), "00") & _
    Format$(Minute(aDate), "00") & _
    Format$(Second(aDate), "00")
End Function

Private Function ParseDate(ByVal sDate As String) As Date
    Dim result As Date
    
    Dim x As Integer
    Dim y As Integer
    Dim z As Integer
    
    x = CInt(Mid$(sDate, 1, 4))
    y = CInt(Mid$(sDate, 5, 2))
    z = CInt(Mid$(sDate, 7, 2))
    result = DateSerial(x, y, z)
    
    x = CInt(Mid$(sDate, 9, 2))
    y = CInt(Mid$(sDate, 11, 2))
    z = CInt(Mid$(sDate, 13, 2))
    result = result + TimeSerial(x, y, z)
    
    ParseDate = result
End Function
