VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SyncItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit
Option Base 0

Private m_Item As Object

Public Property Get OutlookItem() As Object
    Set OutlookItem = m_Item
End Property

Public Property Set OutlookItem(ByVal value As Object)
    Set m_Item = value
End Property


Public Property Get Class() As Integer
    Class = IIf(m_Item Is Nothing, -1, m_Item.Class)
End Property


Public Property Get Status() As Integer
    If (m_Item Is Nothing) Then
        Status = STATUS_UNKNOWN
    Else
        Dim UserProperties As UserProperties
        Set UserProperties = m_Item.UserProperties
        If UserProperties.Find(PROP_LAST_SYNCHRONIZED, True) Is Nothing Then
            Status = STATUS_NEW
            Exit Property
        End If
        Dim lastSynchronized As Date
        Dim lastChanged As Date
        lastSynchronized = UserProperties(PROP_LAST_SYNCHRONIZED).value
        lastChanged = UserProperties.Find("LastModificationTime", False).value
        Dim gap As Long
        gap = DateDiff("s", lastSynchronized, lastChanged)
        If (gap < 5) Then
            Status = STATUS_SYNCHRONIZED
        Else
            Status = STATUS_UPDATED
        End If
    End If
End Property

Public Property Get ID() As String
    If (m_Item Is Nothing) Then
        ID = ""
    Else
        Dim UserProperties As UserProperties
        Set UserProperties = m_Item.UserProperties
        If UserProperties.Find(PROP_CENTRIC_ITEM_ID, True) Is Nothing Then
            ID = ""
        Else
            ID = UserProperties(PROP_CENTRIC_ITEM_ID).value
        End If
    End If
End Property


Public Property Let ID(ByVal value As String)
    GetOrCreateProperty(PROP_CENTRIC_ITEM_ID, olText).value = value
End Property


Public Property Get IsNew() As Boolean
    IsNew = (Status = STATUS_NEW)
End Property

Public Property Get IsSynchronized() As Boolean
    IsSynchronized = (Status = STATUS_SYNCHRONIZED)
End Property

Public Property Get IsUpdated() As Boolean
    IsUpdated = (Status = STATUS_UPDATED)
End Property

Public Property Get Folder() As String
    If m_Item Is Nothing Then
        Folder = Null
        Exit Property
    End If
    
    Dim itemFolder As MAPIFolder
    Set itemFolder = m_Item.parent
    Folder = itemFolder.folderPath
End Property

Public Property Get Label() As String
    If m_Item Is Nothing Then Exit Property
    
    If (Class = olTask) Or (Class = olMail) Or (Class = olAppointment) Then
        Label = m_Item.Subject
    ElseIf Class = olContact Then
        Label = m_Item.FileAs
    End If
End Property

Public Sub Save()
    GetOrCreateProperty(PROP_LAST_SYNCHRONIZED, olDateTime).value = Now
    m_Item.Save
End Sub

'Public Sub MarkAsNonSynchronizable()
    'SetStatus STATUS_NON_SYNCHRONIZABLE
    'm_Item.Save
'End Sub

Private Function GetOrCreateProperty(ByVal propertyName As String, ByVal propertyType As Integer) As UserProperty
    Dim UserProperties As UserProperties
    Set UserProperties = m_Item.UserProperties
    Set GetOrCreateProperty = UserProperties.Find(propertyName, True)
    If (GetOrCreateProperty Is Nothing) Then
        Set GetOrCreateProperty = UserProperties.Add(propertyName, propertyType, False)
    End If
End Function




