VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SyncItemsSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit
Option Base 0

Private WithEvents m_search As Search
Attribute m_search.VB_VarHelpID = -1
Private m_started As Boolean
Private m_itemTypes As dictionary

Public Event Started(ByVal SearchObject As SyncItemsSearch)
Public Event Finished(ByVal SearchObject As SyncItemsSearch)
Public Event Cancelled(ByVal SearchObject As SyncItemsSearch)
Public Event ItemFound(ByVal SearchObject As SyncItemsSearch, ByVal SyncItem As SyncItem)
Public Event LocationSwitch(ByVal Location As String)

Public Sub Start()
    Set m_itemTypes = New dictionary
    If CentricApp.Preferences.SyncContacts Then m_itemTypes.Add olContact, olContact
    If CentricApp.Preferences.SyncTasks Then m_itemTypes.Add olTask, olTask
    If CentricApp.Preferences.SyncAppointments Then m_itemTypes.Add olAppointment, olAppointment
    If CentricApp.Preferences.SyncEmail Then m_itemTypes.Add olMail, olMail
    

    If m_started Then Err.Raise ERR_INVALID_STATE, Description:=MSG_ERR_SEARCH_STARTED
    
    Set m_search = New Search
    
    Dim Filter As String
    Filter = """DAV:getlastmodified"" >= " & GetFormattedIntervalStart
    ' Format$(GetSelectedIntervalStart, "\'D\.MM\.yyyy\'")
    Dim FolderList As FolderList
    Set FolderList = New FolderList
    FolderList.AsString = CentricApp.Preferences.SyncSearchInFolders
    Dim i As Integer
    For i = 0 To FolderList.Count - 1
        m_search.Conditions.Add FolderList(i), Filter, True
    Next i
    
    m_search.IgnoreFolders.AsString = CentricApp.Preferences.SyncIgnoreFolders
    
    m_search.Start
    m_started = True
    RaiseEvent Started(Me)
End Sub

Public Sub Cancel()
    m_search.Cancel
    StopSearch
    RaiseEvent Cancelled(Me)
End Sub

Private Sub StopSearch()
    m_started = False
    Set m_search = Nothing
End Sub

Private Sub Class_Initialize()
    m_started = False
End Sub

Private Sub m_search_Finished(ByVal Search As Search)
    StopSearch
    RaiseEvent Finished(Me)
    Set m_itemTypes = Nothing
End Sub

Private Sub m_search_ItemFound(ByVal Search As Search, ByVal Item As Object)
    If (Not m_itemTypes.Exists(Item.Class)) Then Exit Sub
    Dim SyncItem As New SyncItem
    Set SyncItem.OutlookItem = Item
    If SyncItem.IsSynchronized Then Exit Sub
    RaiseEvent ItemFound(Me, SyncItem)
End Sub

Private Sub m_search_LocationSwitch(ByVal Location As String)
    RaiseEvent LocationSwitch(Location)
End Sub

Private Function GetFormattedIntervalStart() As String
    Dim interval As Date
    interval = GetSelectedIntervalStart
    Dim startOfTheDay As Date
    startOfTheDay = CDate(CLng(interval))
    GetFormattedIntervalStart = "'" & startOfTheDay & " " & FormatDateTime(interval, vbShortTime) & "'"
End Function
