Attribute VB_Name = "UrlUtils"
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

Option Explicit

' Returns host name of the specific URL
Public Function GetHost(ByVal Url As String) As String
    
    ' Remove protocol, port and ending slash if presents
    If InStr(1, Url, "http://") = 1 Then
      Url = Mid(Url, 8)
    End If
      
    If InStr(1, Url, "/") > 1 Then
      Url = Mid(Url, 1, InStr(1, Url, "/") - 1)
    End If
      
    If InStr(1, Url, ":") > 1 Then
      Url = Mid(Url, 1, InStr(1, Url, ":") - 1)
    End If
    
    GetHost = Url
End Function

' Normalizes URL, i.e. forms full form of the URL by adding all optional parts explicitly.
' For example, "www.concursive.com" and "http://www.concursive.com" both will be transformed to http://www.concursive.com/
Public Function GetNormalizedUrl(ByVal Url As String) As String
    If Right(Url, 1) <> "/" Then
      Url = Url & "/"
    End If
    
    GetNormalizedUrl = Url
End Function
