VERSION 5.00
Begin VB.UserControl ctlPreferences 
   ClientHeight    =   3675
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6135
   ScaleHeight     =   3675
   ScaleWidth      =   6135
   Begin VB.CommandButton cmdTestConnection 
      Caption         =   "Test Connection"
      Height          =   375
      Left            =   4620
      TabIndex        =   4
      Top             =   2340
      Width           =   1395
   End
   Begin VB.TextBox TxtUserName 
      Height          =   285
      Left            =   2490
      TabIndex        =   0
      Top             =   900
      Width           =   3495
   End
   Begin VB.TextBox TxtPassword 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   2490
      PasswordChar    =   "*"
      TabIndex        =   1
      Top             =   1320
      Width           =   3495
   End
   Begin VB.TextBox TxtUrl 
      Height          =   285
      Left            =   2490
      TabIndex        =   2
      Top             =   1740
      Width           =   3495
   End
   Begin VB.Frame Frame1 
      Height          =   75
      Left            =   1260
      TabIndex        =   10
      Top             =   210
      Width           =   4755
   End
   Begin VB.Image Image1 
      Height          =   240
      Left            =   570
      Picture         =   "ctlPreferences.ctx":0000
      Top             =   510
      Width           =   240
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "(E.g., http://localhost/)"
      Height          =   195
      Left            =   2490
      TabIndex        =   8
      Top             =   2070
      Width           =   1635
   End
   Begin VB.Label Label1 
      Caption         =   "Provide the following details to access your secure Concourse Suite:"
      Height          =   285
      Left            =   960
      TabIndex        =   7
      Top             =   510
      Width           =   4905
   End
   Begin VB.Label lblusername 
      Caption         =   "Concourse Suite User Name:"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   900
      Width           =   2055
   End
   Begin VB.Label lblPassword 
      Caption         =   "Concourse Suite Password:"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   1320
      Width           =   2175
   End
   Begin VB.Label lblUrl 
      Caption         =   "Concourse Suite Server URL:"
      Height          =   285
      Left            =   240
      TabIndex        =   3
      Top             =   1740
      Width           =   2175
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Configuration     "
      Height          =   195
      Left            =   240
      TabIndex        =   9
      Top             =   180
      Width           =   1155
   End
End
Attribute VB_Name = "ctlPreferences"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concoursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

Option Explicit

Dim m_IsDirty As Boolean
Dim PasswordChanged As Boolean

Public Event Changed()

Private Sub SetDirty(value As Boolean)
    Dim tmp As Boolean
    tmp = m_IsDirty
    m_IsDirty = value
    If (value And (Not tmp)) Then
        RaiseEvent Changed
    End If
End Sub

Public Sub Apply()
    CentricApp.Logger.Debugging "Applying connection preferences..."
    
    CentricApp.Preferences.Url = TxtUrl.text
    CentricApp.Preferences.UserName = TxtUserName.text
    
    If PasswordChanged Then
      CentricApp.Preferences.Password = CalculateMD5(TxtPassword.text)
      PasswordChanged = False
    End If
  
    SetDirty (False)
    CentricApp.Logger.Debugging "Connection preferences saved."
End Sub

Public Property Get IsDirty() As Boolean
    IsDirty = m_IsDirty
End Property

Private Sub cmdTestConnection_Click()
    On Error GoTo handleError
    
    UserControl.MousePointer = vbHourglass

    Dim pwd As String
    If (PasswordChanged) Then
        pwd = CalculateMD5(TxtPassword)
    Else
        pwd = CentricApp.Preferences.Password
    End If

    Dim params As ConnectionParams
    Set params = CreateConnectionParamsWithBasicAuthentication(TxtUrl, TxtUserName, pwd)

    If TestConnection(params) Then
        MsgBox MSG_TEST_CONNECTION_SUCCESS, vbInformation, TITLE_CENTRIC_CRM
    Else
        MsgBox MSG_ERR_CONNECTION_ERROR, vbExclamation, TITLE_CENTRIC_CRM
    End If
  
    UserControl.MousePointer = vbDefault
    Exit Sub

handleError:
    MsgBox Err.Description, vbExclamation, TITLE_CENTRIC_CRM
    UserControl.MousePointer = vbDefault
End Sub

Private Sub TxtPassword_Change()
  SetDirty (True)
  PasswordChanged = True
End Sub

Private Sub TxtUrl_Change()
  SetDirty (True)
End Sub

Private Sub TxtUserName_Change()
  SetDirty (True)
End Sub

Private Sub UserControl_Initialize()
  Display
  SetDirty (False)
  PasswordChanged = False
End Sub

Private Sub Display()
    TxtUserName.text = CentricApp.Preferences.UserName
    TxtPassword.text = "123456789"
    TxtUrl.text = CentricApp.Preferences.Url
End Sub


Private Sub TxtPassword_GotFocus()
  TxtPassword.SelStart = 0
  TxtPassword.SelLength = Len(TxtPassword.text)
End Sub

Private Sub TxtUrl_GotFocus()
  TxtUrl.SelStart = 0
  TxtUrl.SelLength = Len(TxtUrl.text)
End Sub

Private Sub TxtUserName_GotFocus()
  TxtUserName.SelStart = 0
  TxtUserName.SelLength = Len(TxtUserName.text)
End Sub

Private Sub UserControl_InitProperties()
  On Error Resume Next
  'Set OutlookSite = Parent
End Sub
