VERSION 5.00
Begin VB.UserControl ctlSyncPreferences 
   ClientHeight    =   4425
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6660
   ScaleHeight     =   4425
   ScaleWidth      =   6660
   Begin ConcourseSuite.ctlFolderList ctlFolderList 
      Height          =   1935
      Index           =   0
      Left            =   120
      TabIndex        =   7
      Top             =   2400
      Width           =   3255
      _ExtentX        =   5741
      _ExtentY        =   3413
   End
   Begin VB.CheckBox checkTasks 
      Caption         =   "Tasks"
      Height          =   375
      Left            =   240
      TabIndex        =   6
      Top             =   1080
      Width           =   1455
   End
   Begin VB.CheckBox checkEmail 
      Caption         =   "Email Messages"
      Height          =   375
      Left            =   1920
      TabIndex        =   5
      Top             =   720
      Width           =   2175
   End
   Begin VB.CheckBox checkAppointments 
      Caption         =   "Calendar Appointments"
      Height          =   375
      Left            =   1920
      TabIndex        =   4
      Top             =   1080
      Width           =   2175
   End
   Begin VB.CheckBox checkContacts 
      Caption         =   "Contacts"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   720
      Width           =   1455
   End
   Begin VB.ComboBox comboInterval 
      Height          =   315
      ItemData        =   "ctlSyncPreferences.ctx":0000
      Left            =   2760
      List            =   "ctlSyncPreferences.ctx":0002
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   1680
      Width           =   2535
   End
   Begin ConcourseSuite.ctlFolderList ctlFolderList 
      Height          =   1935
      Index           =   1
      Left            =   3360
      TabIndex        =   8
      Top             =   2400
      Width           =   3255
      _ExtentX        =   5741
      _ExtentY        =   3413
   End
   Begin VB.Label Label2 
      Caption         =   $"ctlSyncPreferences.ctx":0004
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   1680
      Width           =   2295
   End
   Begin VB.Label Label1 
      Caption         =   "Include the following for a Sync with Concourse Suite"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   4095
   End
End
Attribute VB_Name = "ctlSyncPreferences"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Concourse Suite Outlook-Plugin
'Copyright (C) 2000-2007 Concursive Corporation.
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; version 2
'of the License.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 

Option Explicit

Private m_IsDirty As Boolean

Public Event Changed()

Private Sub SetDirty(value As Boolean)
    Dim tmp As Boolean
    tmp = m_IsDirty
    m_IsDirty = value
    If (value And (Not tmp)) Then
        RaiseEvent Changed
    End If
End Sub

Public Sub Apply()
    CentricApp.Logger.Debugging "Applying sync preferences..."
    
    CentricApp.Preferences.SyncContacts = checkContacts.value
    CentricApp.Preferences.SyncTasks = checkTasks.value
    CentricApp.Preferences.SyncEmail = checkEmail.value
    CentricApp.Preferences.SyncAppointments = checkAppointments.value
    CentricApp.Preferences.SyncInterval = comboInterval.ListIndex
    CentricApp.Preferences.SyncSearchInFolders = ctlFolderList(0).Folders
    CentricApp.Preferences.SyncIgnoreFolders = ctlFolderList(1).Folders

    m_IsDirty = False
    CentricApp.Logger.Debugging "Sync preferences saved."
End Sub

Public Property Get IsDirty() As Boolean
    IsDirty = m_IsDirty
End Property

Private Sub checkAppointments_Click()
    SetDirty True
End Sub

Private Sub checkContacts_Click()
    SetDirty True
End Sub

Private Sub checkEmail_Click()
    SetDirty True
End Sub

Private Sub checkTasks_Click()
    SetDirty True
End Sub

Private Sub comboInterval_Change()
    SetDirty True
End Sub

Private Sub comboInterval_Click()
    SetDirty True
End Sub

Private Sub ctlFolderList_Changed(Index As Integer)
    SetDirty True
End Sub

Private Sub ctlFolderList_OnAdd(Index As Integer, ByVal Folder As String, Cancel As Boolean)
    Dim Message As String
    If (ctlFolderList(Index).Contains(Folder)) Then
        If Index = 0 Then
            Message = "This folder is already included into the search."
        Else
            Message = "This folder is already excluded from the search."
        End If
        MsgBox Message, vbOKOnly, "Error"
        Cancel = True
    End If
    
    If (ctlFolderList(1 - Index).Contains(Folder)) Then
        If Index = 0 Then
            Message = "This folder is already included into the ignore folder list."
        Else
            Message = "This folder is already included into the searchable folder list."
        End If
        MsgBox Message, vbOKOnly, "Error"
        Cancel = True
    End If
End Sub

Private Sub UserControl_Initialize()
    checkContacts = IIf(CentricApp.Preferences.SyncContacts, 1, 0)
    checkTasks = IIf(CentricApp.Preferences.SyncTasks, 1, 0)
    checkEmail = IIf(CentricApp.Preferences.SyncEmail, 1, 0)
    checkAppointments = IIf(CentricApp.Preferences.SyncAppointments, 1, 0)
    
    Dim labels() As String
    labels = Sync.IntervalLabels
    Dim i As Integer
    For i = LBound(labels) To UBound(labels)
        comboInterval.AddItem labels(i)
    Next i
    
    comboInterval.ListIndex = CentricApp.Preferences.SyncInterval
    
    ctlFolderList(0).Folders = CentricApp.Preferences.SyncSearchInFolders
    ctlFolderList(1).Folders = CentricApp.Preferences.SyncIgnoreFolders
    ctlFolderList(1).Caption = "Ignore folders:"
    
    SetDirty (False)
End Sub
